// ----
// ---- file   : aon_fm_v1_lofi.cpp
// ---- author : bsp
// ---- legal  : Distributed under terms of the MIT license (https://opensource.org/licenses/MIT)
// ----
// ----          Permission is hereby granted, free of charge, to any person obtaining a copy of this software and 
// ----          associated documentation files (the "Software"), to deal in the Software without restriction, including 
// ----          without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// ----          copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to 
// ----          the following conditions:
// ----  
// ----          The above copyright notice and this permission notice shall be included in all copies or substantial 
// ----          portions of the Software.
// ----
// ----          THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
// ----          NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// ----          IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// ----          WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// ----          SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// ----
// ---- info   : auto-generated by "Cycle"
// ----           $ g++ -Wall -Wno-unused-function -Wno-unused-variable -I../../tksampler -c aon_fm_v1_lofi.cpp -o aon_fm_v1_lofi.o
// ---- created: 07Dec2023 11:57:33
// ----
// ----
// ----

#include <plugin.h>

#include <stdlib.h>
#include <math.h>
#include <string.h>




#define PARAM_CARRIER_WAVE       0
#define PARAM_CARRIER_FREQ       1
#define PARAM_MOD_WAVE           2
#define PARAM_MOD_FREQ           3
#define PARAM_MOD_AMP            4
#define PARAM_MOD_KBD            5
#define PARAM_CARRIER_KBD        6
#define PARAM_MOD_FLT            7
#define NUM_PARAMS               8
static const char *loc_param_names[NUM_PARAMS] = {
   "carrier_wave",            // 0: CARRIER_WAVE
   "carrier_freq",            // 1: CARRIER_FREQ
   "mod_wave",                // 2: MOD_WAVE
   "mod_freq",                // 3: MOD_FREQ
   "mod_amp",                 // 4: MOD_AMP
   "mod_kbd",                 // 5: MOD_KBD
   "carrier_kbd",             // 6: CARRIER_KBD
   "mod_flt",                 // 7: MOD_FLT

};
static float loc_param_resets[NUM_PARAMS] = {
   0.0f,                      // 0: CARRIER_WAVE
   0.5f,                      // 1: CARRIER_FREQ
   0.0f,                      // 2: MOD_WAVE
   0.5f,                      // 3: MOD_FREQ
   0.5f,                      // 4: MOD_AMP
   0.625f,                    // 5: MOD_KBD
   0.625f,                    // 6: CARRIER_KBD
   0.8f,                      // 7: MOD_FLT

};

#define MOD_CARRIER_WAVE         0
#define MOD_CARRIER_FREQ         1
#define MOD_MOD_WAVE             2
#define MOD_MOD_FREQ             3
#define MOD_MOD_AMP              4
#define MOD_MOD_FLT              5
#define NUM_MODS                 6
static const char *loc_mod_names[NUM_MODS] = {
   "carrier_wave",         // 0: CARRIER_WAVE
   "carrier_freq",         // 1: CARRIER_FREQ
   "mod_wave",             // 2: MOD_WAVE
   "mod_freq",             // 3: MOD_FREQ
   "mod_amp",              // 4: MOD_AMP
   "mod_flt",              // 5: MOD_FLT

};

typedef struct aon_fm_v1_lofi_info_s {
   st_plugin_info_t base;
} aon_fm_v1_lofi_info_t;

typedef struct aon_fm_v1_lofi_shared_s {
   st_plugin_shared_t base;
   float params[NUM_PARAMS];

} aon_fm_v1_lofi_shared_t;

typedef struct aon_fm_v1_lofi_voice_s {
   st_plugin_voice_t base;
   float             sample_rate;
   float             note_speed_fixed;
   float             note_speed_cur;
   float             note_speed_inc;
   float             note_cur;
   float             note_inc;
   float             mods[NUM_MODS];
   float mod_carrier_wave_cur;
   float mod_carrier_wave_inc;
   float mod_carrier_freq_cur;
   float mod_carrier_freq_inc;
   float mod_mod_wave_cur;
   float mod_mod_wave_inc;
   float mod_mod_freq_cur;
   float mod_mod_freq_inc;
   float mod_mod_amp_cur;
   float mod_mod_amp_inc;
   float mod_mod_flt_cur;
   float mod_mod_flt_inc;

   float tmp1_kbd;
   float tmp2_off;
   float tmp3_scl;
   float tmp4_kbd;
   float tmp5_off;
   float tmp6_scl;
   float tmp7_kbd;
   float tmp8_off;
   float tmp9_scl;
   short tmp10_out_i;
   int tmp11_zlp_pos;
   short tmp12_zlp_sub_off_x;
   float tmp13_f2i;
   short tmp15_rate;
   float tmp16_f2i;
   short tmp17_seq;
   float tmp18_f2i;
   float tmp19_f2i;
   short tmp20_seq;
   int tmp21_zlp_pos;
   short tmp22_zlp_sub_off_x;
   float tmp23_f2i;
   short tmp25_rate;
   float tmp26_f2i;
   short tmp27_seq;
   float tmp28_f2i;
   float tmp29_f2i;
   short tmp30_seq;
   short tmp31_svf_lp;
   short tmp32_svf_hp;
   short tmp33_svf_bp;
   short tmp34_freq;
   float tmp35_f2i;
   short tmp36_seq;
   float tmp37_f2i;
   short tmp38_seq;
   float tmp39_flt_last;
   float var_x;
   float var_v_carrier_kbd;
   float var_v_mod_kbd;
   float var_v_mod_flt;

} aon_fm_v1_lofi_voice_t;

#define loop(X)  for(unsigned int i = 0u; i < (X); i++)
#define clamp(a,b,c) (((a)<(b))?(b):(((a)>(c))?(c):(a)))

static inline float mathLerpf(float _a, float _b, float _t) { return _a + (_b - _a) * _t; }
static inline float mathClampf(float a, float b, float c) { return (((a)<(b))?(b):(((a)>(c))?(c):(a))); }
static inline float mathMinf(float a, float b) { return (a<b)?a:b; }
static inline float mathMaxf(float a, float b) { return (a>b)?a:b; }
static inline float mathAbsMaxf(float _x, float _y) { return ( ( (_x<0.0f)?-_x:_x)>((_y<0.0f)?-_y:_y)?_x:_y ); }
static inline float mathAbsMinf(float _x, float _y) { return ( ((_x<0.0f)?-_x:_x)<((_y<0.0f)?-_y:_y)?_x:_y ); }
static inline float frac(float _x) { return _x - ((int)_x); }

static inline float winLinear(const float *_s, float _index) {
   int idx = (int)_index;
   float r = _index - (float)idx;
   return mathLerpf(_s[idx], _s[idx+1], r);
}

#ifdef AMIGA
static inline int mulsw(short b,short c) {
   int a;
   asm("mulsw %2,%0":"=d"(a): "0"(c),"d"(b): "cc");
   return a;
}
#else
static inline int mulsw(short b,short c) {
  return b * c;
}
#endif // AMIGA
#define Dmulsw_shr(A,B) (mulsw(A, B) >> 11)


static float ffrac_s(float _f) { int i; if(_f >= 0.0f) { i = (int)_f; return _f - (float)i; } else { i = (int)-_f; return 1.0f - (-_f - (float)i); } }

static float loc_bipolar_to_scale(const float _t, const float _div, const float _mul) {
   // t (-1..1) => /_div .. *_mul
   
   float s;

   if(_t < 0.0f)
   {
      s = (1.0f / _div);
      s = 1.0f + (s - 1.0f) * -_t;
      if(s < 0.0f)
         s = 0.0f;
   }
   else
   {
      s = _mul;
      s = 1.0f + (s - 1.0f) * _t;
   }
   
   return s;
}

static const float loc_smp_aon_fm_oscwaves[1536] = {
   0.0233154f, 0.0703735f, 0.117432f, 0.16449f, 0.211548f, 0.258606f, 0.305664f, 0.352722f
   , 0.39978f, 0.446838f, 0.486084f, 0.533112f, 0.572327f, 0.611542f, 0.650757f, 0.682159f
   , 0.721375f, 0.752747f, 0.784119f, 0.815491f, 0.83902f, 0.862579f, 0.886108f, 0.909607f
   , 0.925323f, 0.94101f, 0.956696f, 0.964569f, 0.980225f, 0.988068f, 0.995911f, 0.995941f
   , 0.995941f, 0.995941f, 0.988129f, 0.980286f, 0.972443f, 0.964569f, 0.948914f, 0.933228f
   , 0.909698f, 0.8862f, 0.862671f, 0.839111f, 0.80777f, 0.776398f, 0.745026f, 0.713654f
   , 0.674469f, 0.635254f, 0.603851f, 0.556824f, 0.517609f, 0.478363f, 0.431335f, 0.384277f
   , 0.337219f, 0.298004f, 0.250946f, 0.203888f, 0.15683f, 0.109772f, 0.0627136f, 0.0156555f
   , -0.0233154f, -0.0703735f, -0.117432f, -0.16449f, -0.211548f, -0.258606f, -0.305664f, -0.352722f
   , -0.39978f, -0.446838f, -0.486053f, -0.533112f, -0.572327f, -0.611542f, -0.650757f, -0.682159f
   , -0.721344f, -0.752747f, -0.784119f, -0.807678f, -0.83902f, -0.862579f, -0.886108f, -0.909607f
   , -0.925323f, -0.94101f, -0.956696f, -0.964569f, -0.980225f, -0.988068f, -0.988098f, -0.988098f
   , -0.988098f, -0.988098f, -0.980286f, -0.972443f, -0.9646f, -0.956726f, -0.941071f, -0.925385f
   , -0.901886f, -0.886169f, -0.86264f, -0.831299f, -0.80777f, -0.776398f, -0.745026f, -0.713654f
   , -0.674469f, -0.643066f, -0.603851f, -0.564636f, -0.525421f, -0.478394f, -0.439148f, -0.399963f
   , -0.352905f, -0.305847f, -0.258789f, -0.211731f, -0.164673f, -0.117615f, -0.0705566f, -0.0156555f
   , 0.0155029f, 0.046875f, 0.0782471f, 0.109619f, 0.140991f, 0.172363f, 0.203735f, 0.235107f
   , 0.266479f, 0.297852f, 0.329224f, 0.360596f, 0.391968f, 0.42334f, 0.454712f, 0.486084f
   , 0.517456f, 0.548828f, 0.5802f, 0.611572f, 0.642944f, 0.674316f, 0.705688f, 0.737061f
   , 0.768433f, 0.799805f, 0.831177f, 0.862549f, 0.893921f, 0.925293f, 0.956665f, 0.988037f
   , 0.980316f, 0.948944f, 0.917572f, 0.8862f, 0.854828f, 0.823456f, 0.792084f, 0.760712f
   , 0.72934f, 0.697968f, 0.666595f, 0.635223f, 0.603851f, 0.572479f, 0.541107f, 0.509735f
   , 0.478363f, 0.446991f, 0.415619f, 0.384247f, 0.352875f, 0.321503f, 0.290131f, 0.258759f
   , 0.227386f, 0.196014f, 0.164642f, 0.13327f, 0.101898f, 0.0705261f, 0.0391541f, 0.00778198f
   , -0.0155029f, -0.046875f, -0.0782471f, -0.109619f, -0.140991f, -0.172363f, -0.203735f, -0.235107f
   , -0.266479f, -0.297852f, -0.329224f, -0.360596f, -0.391968f, -0.42334f, -0.454712f, -0.486084f
   , -0.517456f, -0.548828f, -0.5802f, -0.611572f, -0.642944f, -0.674316f, -0.705688f, -0.737061f
   , -0.768433f, -0.799805f, -0.831177f, -0.862549f, -0.893921f, -0.925293f, -0.956665f, -0.99585f
   , -0.980286f, -0.948944f, -0.917572f, -0.8862f, -0.854828f, -0.823456f, -0.792084f, -0.760712f
   , -0.72934f, -0.697968f, -0.666595f, -0.635223f, -0.603851f, -0.572479f, -0.541107f, -0.509735f
   , -0.478363f, -0.446991f, -0.415619f, -0.384247f, -0.352875f, -0.321503f, -0.290131f, -0.258759f
   , -0.227386f, -0.196014f, -0.164642f, -0.13327f, -0.101898f, -0.0705261f, -0.0391541f, -0.00778198f
   , -0.995941f, -0.995941f, -0.988129f, -0.988098f, -0.980255f, -0.972412f, -0.9646f, -0.956757f
   , -0.948914f, -0.948883f, -0.94104f, -0.933197f, -0.925354f, -0.917511f, -0.909668f, -0.894012f
   , -0.886169f, -0.878326f, -0.870483f, -0.86261f, -0.846954f, -0.839111f, -0.831268f, -0.815582f
   , -0.807739f, -0.799866f, -0.78421f, -0.776337f, -0.760681f, -0.744995f, -0.737122f, -0.721466f
   , -0.70578f, -0.690094f, -0.674408f, -0.658722f, -0.643036f, -0.62735f, -0.611664f, -0.595978f
   , -0.572449f, -0.556763f, -0.533264f, -0.517548f, -0.494049f, -0.47052f, -0.454803f, -0.431274f
   , -0.407745f, -0.384247f, -0.360687f, -0.337158f, -0.313629f, -0.282288f, -0.258759f, -0.235199f
   , -0.203857f, -0.180328f, -0.148956f, -0.125427f, -0.0940552f, -0.0704956f, -0.0391541f, -0.00778198f
   , 0.00769043f, 0.039032f, 0.0704041f, 0.0939331f, 0.125305f, 0.148865f, 0.180206f, 0.203766f
   , 0.235107f, 0.258636f, 0.282196f, 0.313538f, 0.337067f, 0.360596f, 0.384125f, 0.407684f
   , 0.431183f, 0.454712f, 0.470428f, 0.493958f, 0.517487f, 0.533173f, 0.556702f, 0.572388f
   , 0.595886f, 0.611603f, 0.627289f, 0.642975f, 0.658661f, 0.674347f, 0.690033f, 0.705719f
   , 0.721405f, 0.737091f, 0.744934f, 0.76062f, 0.776306f, 0.784149f, 0.799835f, 0.807678f
   , 0.815552f, 0.831207f, 0.839081f, 0.846924f, 0.862579f, 0.870422f, 0.878296f, 0.886139f
   , 0.893982f, 0.909637f, 0.91748f, 0.925323f, 0.933167f, 0.94101f, 0.948853f, 0.948883f
   , 0.956726f, 0.964569f, 0.972412f, 0.980225f, 0.988068f, 0.988098f, 0.995941f, 0.995941f
   , 0.972504f, 0.90979f, 0.847046f, 0.784302f, 0.729401f, 0.674469f, 0.611755f, 0.556854f
   , 0.501953f, 0.447052f, 0.392151f, 0.345062f, 0.290192f, 0.243103f, 0.196045f, 0.148987f
   , 0.101929f, 0.0548706f, 0.0078125f, -0.0311584f, -0.0703735f, -0.117432f, -0.156647f, -0.195862f
   , -0.235077f, -0.274292f, -0.313507f, -0.34491f, -0.384094f, -0.415497f, -0.446869f, -0.478241f
   , -0.509613f, -0.540985f, -0.572357f, -0.603729f, -0.627258f, -0.65863f, -0.682159f, -0.705688f
   , -0.729218f, -0.752747f, -0.776276f, -0.791992f, -0.815491f, -0.831207f, -0.846893f, -0.862579f
   , -0.878265f, -0.893951f, -0.909637f, -0.925323f, -0.933167f, -0.948853f, -0.956696f, -0.964539f
   , -0.972382f, -0.980225f, -0.988068f, -0.988098f, -0.995911f, -0.995941f, -0.995941f, -0.995941f
   , -0.995941f, -0.995941f, -0.995941f, -0.995941f, -0.988129f, -0.988098f, -0.980255f, -0.972412f
   , -0.9646f, -0.956726f, -0.948883f, -0.933228f, -0.925385f, -0.909698f, -0.894012f, -0.886139f
   , -0.870483f, -0.846954f, -0.831268f, -0.815582f, -0.792084f, -0.776367f, -0.752838f, -0.729309f
   , -0.705811f, -0.682251f, -0.658722f, -0.62738f, -0.603851f, -0.572479f, -0.541107f, -0.517548f
   , -0.486206f, -0.447021f, -0.415619f, -0.384247f, -0.345062f, -0.31366f, -0.274445f, -0.23526f
   , -0.196045f, -0.15683f, -0.117584f, -0.0705566f, -0.0313416f, 0.0154419f, 0.0546875f, 0.0939026f
   , 0.140961f, 0.195831f, 0.24292f, 0.289978f, 0.344849f, 0.391937f, 0.446838f, 0.501709f
   , 0.55661f, 0.611511f, 0.666443f, 0.729156f, 0.784058f, 0.846802f, 0.909546f, 0.964447f
   , -0.995941f, -0.995941f, -0.980286f, -0.972443f, -0.948944f, -0.933228f, -0.909698f, -0.878357f
   , -0.846985f, -0.815613f, -0.784241f, -0.752869f, -0.713654f, -0.674469f, -0.635254f, -0.596039f
   , -0.564636f, -0.525421f, -0.486206f, -0.446991f, -0.407776f, -0.368561f, -0.329376f, -0.297974f
   , -0.258789f, -0.227386f, -0.196014f, -0.164642f, -0.13327f, -0.101898f, -0.0783691f, -0.0548096f
   , -0.023468f, -0.00775146f, 0.00769043f, 0.031189f, 0.0469055f, 0.0625916f, 0.0782776f, 0.0861206f
   , 0.101807f, 0.10965f, 0.117493f, 0.117523f, 0.125366f, 0.125366f, 0.133209f, 0.133209f
   , 0.125397f, 0.125366f, 0.125366f, 0.117523f, 0.109711f, 0.101868f, 0.0940247f, 0.0861816f
   , 0.0783386f, 0.0704651f, 0.0548096f, 0.046936f, 0.0312805f, 0.023407f, 0.00775146f, 0.0f
   , -0.00769043f, -0.0233765f, -0.0312195f, -0.0469055f, -0.0547791f, -0.0704346f, -0.0782776f, -0.0861511f
   , -0.101807f, -0.10965f, -0.117493f, -0.125336f, -0.125366f, -0.133209f, -0.133209f, -0.141052f
   , -0.141052f, -0.141052f, -0.141052f, -0.133209f, -0.133209f, -0.125366f, -0.117523f, -0.10968f
   , -0.0940247f, -0.0861511f, -0.0704956f, -0.0548096f, -0.0312805f, -0.0155945f, 0.00765991f, 0.0233459f
   , 0.046875f, 0.0704346f, 0.101776f, 0.133148f, 0.156677f, 0.188049f, 0.227264f, 0.258636f
   , 0.297821f, 0.329224f, 0.368439f, 0.407623f, 0.446838f, 0.486053f, 0.525269f, 0.564484f
   , 0.603699f, 0.642914f, 0.674316f, 0.713531f, 0.752716f, 0.784119f, 0.815491f, 0.854706f
   , 0.878235f, 0.909607f, 0.933136f, 0.956665f, 0.972382f, 0.988068f, 0.995911f, 0.995941f
   , -0.949066f, -0.85495f, -0.752991f, -0.658875f, -0.556946f, -0.462799f, -0.368683f, -0.274567f
   , -0.188293f, -0.0941772f, -0.00790405f, 0.0624695f, 0.148743f, 0.227173f, 0.305603f, 0.37619f
   , 0.446808f, 0.509552f, 0.572296f, 0.63504f, 0.689941f, 0.73703f, 0.784088f, 0.831146f
   , 0.862549f, 0.901764f, 0.925293f, 0.948853f, 0.972382f, 0.988068f, 0.995911f, 0.995941f
   , 0.995941f, 0.995941f, 0.988098f, 0.972443f, 0.948944f, 0.925415f, 0.901855f, 0.862701f
   , 0.831299f, 0.784271f, 0.737213f, 0.690155f, 0.635254f, 0.57254f, 0.509796f, 0.447052f
   , 0.376495f, 0.305878f, 0.227478f, 0.149048f, 0.0628052f, -0.0153809f, -0.0938416f, -0.187927f
   , -0.274231f, -0.368317f, -0.462433f, -0.556549f, -0.658508f, -0.752625f, -0.854553f, -0.9487f
   , 0.902008f, 0.800079f, 0.705933f, 0.611816f, 0.509857f, 0.415741f, 0.321625f, 0.235321f
   , 0.141235f, 0.0549316f, -0.0310669f, -0.109497f, -0.187958f, -0.266388f, -0.337006f, -0.415405f
   , -0.47818f, -0.540924f, -0.603668f, -0.6586f, -0.713501f, -0.760559f, -0.807617f, -0.846863f
   , -0.886047f, -0.909637f, -0.940979f, -0.964508f, -0.980225f, -0.988098f, -0.995941f, -0.995941f
   , -0.995941f, -0.988129f, -0.980286f, -0.9646f, -0.941071f, -0.909729f, -0.8862f, -0.846985f
   , -0.8078f, -0.760742f, -0.713684f, -0.658813f, -0.603912f, -0.541168f, -0.478424f, -0.41568f
   , -0.33728f, -0.266693f, -0.188263f, -0.109833f, -0.0235596f, 0.0545959f, 0.140869f, 0.234985f
   , 0.321259f, 0.415375f, 0.509491f, 0.61142f, 0.705566f, 0.799683f, 0.901642f, 0.995758f
   , -0.00769043f, -0.0233765f, -0.0390625f, -0.0547485f, -0.0704346f, -0.0861206f, -0.101807f, -0.117493f
   , -0.133179f, -0.148865f, -0.164551f, -0.180237f, -0.195923f, -0.211609f, -0.227295f, -0.242981f
   , -0.258667f, -0.274353f, -0.290039f, -0.305725f, -0.321411f, -0.337097f, -0.352783f, -0.368469f
   , -0.384155f, -0.399841f, -0.415527f, -0.431213f, -0.446899f, -0.462585f, -0.478271f, -0.493958f
   , 0.509644f, 0.52533f, 0.541016f, 0.556702f, 0.572388f, 0.588074f, 0.60376f, 0.619446f
   , 0.635132f, 0.650818f, 0.666504f, 0.68219f, 0.697876f, 0.713562f, 0.729248f, 0.744934f
   , 0.76062f, 0.776306f, 0.791992f, 0.807678f, 0.823364f, 0.83905f, 0.854736f, 0.870422f
   , 0.886108f, 0.901794f, 0.91748f, 0.933167f, 0.948853f, 0.964539f, 0.980225f, 0.995911f
   , -0.988129f, -0.972443f, -0.956757f, -0.941071f, -0.925385f, -0.909698f, -0.894012f, -0.878326f
   , -0.86264f, -0.846954f, -0.831268f, -0.815582f, -0.799896f, -0.78421f, -0.768524f, -0.752838f
   , -0.737152f, -0.721466f, -0.70578f, -0.690094f, -0.674408f, -0.658722f, -0.643036f, -0.62735f
   , -0.611664f, -0.595978f, -0.580292f, -0.564606f, -0.54892f, -0.533234f, -0.517548f, -0.501862f
   , 0.486176f, 0.47049f, 0.454803f, 0.439117f, 0.423431f, 0.407745f, 0.392059f, 0.376373f
   , 0.360687f, 0.345001f, 0.329315f, 0.313629f, 0.297943f, 0.282257f, 0.266571f, 0.250885f
   , 0.235199f, 0.219513f, 0.203827f, 0.188141f, 0.172455f, 0.156769f, 0.141083f, 0.125397f
   , 0.109711f, 0.0940247f, 0.0783386f, 0.0626526f, 0.0469666f, 0.0312805f, 0.0155945f, 0.0f
   , -0.964691f, -0.901947f, -0.839203f, -0.776459f, -0.713715f, -0.65097f, -0.588226f, -0.525482f
   , -0.462738f, -0.399994f, -0.33725f, -0.274506f, -0.211761f, -0.149017f, -0.0862732f, -0.0235291f
   , 0.0311279f, 0.0938721f, 0.156616f, 0.21936f, 0.282104f, 0.344849f, 0.407593f, 0.470337f
   , 0.533081f, 0.595825f, 0.658569f, 0.721313f, 0.784058f, 0.846802f, 0.909546f, 0.97229f
   , 0.980316f, 0.948944f, 0.917572f, 0.8862f, 0.854828f, 0.823456f, 0.792084f, 0.760712f
   , 0.72934f, 0.697968f, 0.666595f, 0.635223f, 0.603851f, 0.572479f, 0.541107f, 0.509735f
   , 0.478363f, 0.446991f, 0.415619f, 0.384247f, 0.352875f, 0.321503f, 0.290131f, 0.258759f
   , 0.227386f, 0.196014f, 0.164642f, 0.13327f, 0.101898f, 0.0705261f, 0.0391541f, 0.00778198f
   , 0.0155029f, 0.046875f, 0.0782471f, 0.109619f, 0.140991f, 0.172363f, 0.203735f, 0.235107f
   , 0.266479f, 0.297852f, 0.329224f, 0.360596f, 0.391968f, 0.42334f, 0.454712f, 0.486084f
   , 0.517456f, 0.548828f, 0.5802f, 0.611572f, 0.642944f, 0.674316f, 0.705688f, 0.737061f
   , 0.768433f, 0.799805f, 0.831177f, 0.862549f, 0.893921f, 0.925293f, 0.956665f, 0.988037f
   , 0.949005f, 0.886261f, 0.823517f, 0.760773f, 0.698029f, 0.635284f, 0.57254f, 0.509796f
   , 0.447052f, 0.384308f, 0.321564f, 0.25882f, 0.196075f, 0.133331f, 0.0705872f, 0.00784302f
   , -0.046814f, -0.109558f, -0.172302f, -0.235046f, -0.297791f, -0.360535f, -0.423279f, -0.486023f
   , -0.548767f, -0.611511f, -0.674255f, -0.737f, -0.799744f, -0.862488f, -0.925232f, -0.987976f
   , 0.368683f, 0.322357f, 0.291351f, 0.244659f, 0.197968f, 0.16684f, 0.135712f, 0.104523f
   , 0.0733948f, 0.0578308f, 0.0266418f, 0.0110779f, -0.00415039f, -0.0197144f, -0.0352783f, -0.0665283f
   , -0.0820923f, -0.0976562f, -0.11322f, -0.128845f, -0.144409f, -0.160034f, -0.175659f, -0.191284f
   , -0.206909f, -0.222534f, -0.238159f, -0.253784f, -0.285034f, -0.285034f, -0.316284f, -0.331909f
   , -0.347595f, -0.36322f, -0.378845f, -0.394531f, -0.410217f, -0.425842f, -0.441528f, -0.457214f
   , -0.472839f, -0.488525f, -0.504211f, -0.519897f, -0.535583f, -0.55127f, -0.566956f, -0.582642f
   , -0.598328f, -0.614014f, -0.629761f, -0.645447f, -0.661133f, -0.692444f, -0.708191f, -0.739502f
   , -0.770874f, -0.78656f, -0.817932f, -0.833618f, -0.864929f, -0.896301f, -0.943298f, -0.97467f
   , -0.990356f, -0.958984f, -0.927612f, -0.880615f, -0.849304f, -0.833557f, -0.802246f, -0.786499f
   , -0.755188f, -0.723816f, -0.692505f, -0.676819f, -0.661133f, -0.645386f, -0.6297f, -0.598389f
   , -0.598328f, -0.567017f, -0.551331f, -0.535645f, -0.519958f, -0.504272f, -0.488586f, -0.4729f
   , -0.472839f, -0.457153f, -0.441528f, -0.410217f, -0.394531f, -0.378906f, -0.378845f, -0.36322f
   , -0.347595f, -0.316284f, -0.300659f, -0.285034f, -0.269409f, -0.253784f, -0.238159f, -0.206909f
   , -0.191284f, -0.175659f, -0.175659f, -0.160034f, -0.14447f, -0.128845f, -0.0976562f, -0.0976562f
   , -0.0664673f, -0.0509033f, -0.0353394f, -0.0197754f, -0.00421143f, 0.0267029f, 0.0422668f, 0.0733948f
   , 0.0889587f, 0.120148f, 0.151276f, 0.182404f, 0.213531f, 0.260162f, 0.306854f, 0.353363f
   , -0.988129f, -0.972443f, -0.956757f, -0.941071f, -0.925385f, -0.909698f, -0.894012f, -0.878326f
   , -0.86264f, -0.846954f, -0.831268f, -0.815582f, -0.799896f, -0.78421f, -0.768524f, -0.752838f
   , -0.737152f, -0.721466f, -0.70578f, -0.690094f, -0.674408f, -0.658722f, -0.643036f, -0.62735f
   , -0.611664f, -0.595978f, -0.580292f, -0.564606f, -0.54892f, -0.533234f, -0.517548f, -0.501862f
   , -0.486176f, -0.47049f, -0.454803f, -0.439117f, -0.423431f, -0.407745f, -0.392059f, -0.376373f
   , -0.360687f, -0.345001f, -0.329315f, -0.313629f, -0.297943f, -0.282257f, -0.266571f, -0.250885f
   , -0.235199f, -0.219513f, -0.203827f, -0.188141f, -0.172455f, -0.156769f, -0.141083f, -0.125397f
   , -0.109711f, -0.0940247f, -0.0783386f, -0.0626526f, -0.0469666f, -0.0312805f, -0.0155945f, 0.0f
   , 0.00769043f, 0.0233765f, 0.0390625f, 0.0547485f, 0.0704346f, 0.0861206f, 0.101807f, 0.117493f
   , 0.133179f, 0.148865f, 0.164551f, 0.180237f, 0.195923f, 0.211609f, 0.227295f, 0.242981f
   , 0.258667f, 0.274353f, 0.290039f, 0.305725f, 0.321411f, 0.337097f, 0.352783f, 0.368469f
   , 0.384155f, 0.399841f, 0.415527f, 0.431213f, 0.446899f, 0.462585f, 0.478271f, 0.493958f
   , 0.509644f, 0.52533f, 0.541016f, 0.556702f, 0.572388f, 0.588074f, 0.60376f, 0.619446f
   , 0.635132f, 0.650818f, 0.666504f, 0.68219f, 0.697876f, 0.713562f, 0.729248f, 0.744934f
   , 0.76062f, 0.776306f, 0.791992f, 0.807678f, 0.823364f, 0.83905f, 0.854736f, 0.870422f
   , 0.886108f, 0.901794f, 0.91748f, 0.933167f, 0.948853f, 0.964539f, 0.980225f, 0.995911f
   , -0.769104f, -0.627563f, -0.384766f, -0.235352f, -0.133362f, -0.164551f, -0.180267f, -0.141113f
   , -0.0941772f, 0.0779724f, 0.227051f, 0.321228f, 0.454559f, 0.47049f, 0.431244f, 0.540894f
   , 0.556671f, 0.572418f, 0.603729f, 0.736786f, 0.776367f, 0.659058f, 0.5177f, 0.486237f
   , 0.415771f, 0.345093f, 0.368439f, 0.345062f, 0.313599f, 0.211914f, 0.242889f, 0.368256f
   , 0.329529f, 0.17276f, 0.117493f, 0.125397f, 0.180176f, 0.203705f, 0.172546f, 0.156738f
   , 0.203674f, 0.196014f, 0.250732f, 0.188232f, 0.102051f, 0.00784302f, -0.0233765f, 0.0f
   , 0.117157f, 0.188019f, 0.242981f, 0.24295f, 0.235199f, 0.149109f, 0.180115f, 0.282074f
   , 0.384064f, 0.415375f, 0.493866f, 0.61142f, 0.713348f, 0.776276f, 0.768585f, 0.729248f
   , 0.807556f, 0.878265f, 0.8078f, 0.752869f, 0.760712f, 0.682343f, 0.658752f, 0.776031f
   , 0.901611f, 0.980194f, 0.956818f, 0.831512f, 0.705994f, 0.588287f, 0.509796f, 0.517517f
   , 0.58786f, 0.650726f, 0.729156f, 0.752747f, 0.596375f, 0.408081f, 0.274475f, 0.235229f
   , 0.289917f, 0.368317f, 0.493805f, 0.564514f, 0.470703f, 0.462616f, 0.44693f, 0.407837f
   , 0.360779f, 0.219788f, 0.141235f, 0.0705566f, -0.0779724f, -0.10965f, -0.117523f, -0.0627747f
   , 0.0309753f, -0.0153809f, 0.093811f, 0.227112f, 0.243011f, 0.133484f, 0.0313721f, -0.0310974f
   , -0.0233765f, 0.0545044f, 0.148743f, 0.289795f, 0.290131f, 0.172729f, 0.000183105f, -0.156464f
   , -0.195953f, -0.0942688f, 0.0232239f, 0.117279f, 0.195831f, 0.250793f, 0.164734f, 0.000244141f
   , 0.0389404f, 0.125183f, 0.203644f, 0.282074f, 0.368347f, 0.438934f, 0.517365f, 0.587952f
   , 0.650726f, 0.71347f, 0.768372f, 0.81546f, 0.862518f, 0.901733f, 0.933136f, 0.956696f
   , 0.980225f, 0.988098f, 0.995941f, 0.995941f, 0.995941f, 0.980286f, 0.9646f, 0.941071f
   , 0.909729f, 0.878357f, 0.839142f, 0.799927f, 0.752899f, 0.698029f, 0.65094f, 0.596039f
   , 0.541138f, 0.478424f, 0.423523f, 0.368591f, 0.305878f, 0.250977f, 0.196075f, 0.148987f
   , 0.0940857f, 0.0470276f, 0.0f, -0.0311584f, -0.0703735f, -0.101776f, -0.125336f, -0.148865f
   , -0.172394f, -0.18808f, -0.195953f, -0.203796f, -0.203796f, -0.203796f, -0.195984f, -0.188141f
   , -0.172455f, -0.156769f, -0.13327f, -0.117554f, -0.0940247f, -0.0626831f, -0.0391541f, -0.00778198f
   , 0.00769043f, 0.039032f, 0.0625916f, 0.0939331f, 0.117462f, 0.133179f, 0.156708f, 0.172394f
   , 0.18808f, 0.195953f, 0.203796f, 0.203796f, 0.203796f, 0.195984f, 0.188141f, 0.172455f
   , 0.148956f, 0.125427f, 0.101898f, 0.0705261f, 0.031311f, -0.00762939f, -0.0468445f, -0.0939026f
   , -0.148773f, -0.195862f, -0.250763f, -0.305664f, -0.368378f, -0.423279f, -0.47821f, -0.540924f
   , -0.595825f, -0.650726f, -0.697815f, -0.752716f, -0.799774f, -0.838989f, -0.878204f, -0.909607f
   , -0.940979f, -0.964508f, -0.980225f, -0.995911f, -0.995941f, -0.995941f, -0.988129f, -0.980286f
   , -0.956787f, -0.933258f, -0.901886f, -0.862671f, -0.815643f, -0.768585f, -0.713684f, -0.65097f
   , -0.588226f, -0.517639f, -0.43924f, -0.368622f, -0.28241f, -0.203949f, -0.125519f, -0.0392456f
};
static const float *loc_smp_aon_fm_oscwaves_zone0 = loc_smp_aon_fm_oscwaves + 0;  // ref 1/1, zone 1/14 #frames=1536
static void loc_prepare(st_plugin_voice_t *_voice);

void loc_prepare(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(aon_fm_v1_lofi_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(aon_fm_v1_lofi_shared_t);

   int tmp11_zlp_pos;
   int tmp21_zlp_pos;
   float out = 0.0f;
   // -------- lane "prepare" modIdx=0
   
   // -- mod="1" dstVar=out
   out = 1.0f;
   
   // -- mod="kbd" dstVar=out
   out *= 127.0f;
   
   // ---- mod="kbd" input "kbd" seq 1/1
   
   // -- mod="$p_carrier_kbd" dstVar=voice->tmp1_kbd
   voice->tmp1_kbd = shared->params[PARAM_CARRIER_KBD] * 8.0f - 4.0f;
   
   // ---- mod="kbd" input "off" seq 1/1
   
   // -- mod="0.0833333" dstVar=voice->tmp2_off
   voice->tmp2_off = 0.0833333f;
   voice->tmp3_scl = 4;
   out += (voice->note_cur + (voice->tmp2_off * 12.0f) - 64.0f) * voice->tmp1_kbd;
   #ifdef OVERSAMPLE_FACTOR
   out = ((440.0f/32.0f)*expf( ((out-9.0f)/12.0f)*logf(2.0f) )) / (voice->sample_rate * OVERSAMPLE_FACTOR);
   #else
   out = ((440.0f/32.0f)*expf( ((out-9.0f)/12.0f)*logf(2.0f) )) / voice->sample_rate;
   #endif
   out *= voice->tmp3_scl;
   
   // -- mod="sto v_carrier_kbd" dstVar=out
   voice->var_v_carrier_kbd = out;
   
   // -- mod="1" dstVar=out
   out = 1.0f;
   
   // -- mod="kbd" dstVar=out
   out *= 127.0f;
   
   // ---- mod="kbd" input "kbd" seq 1/1
   
   // -- mod="$p_mod_kbd" dstVar=voice->tmp4_kbd
   voice->tmp4_kbd = shared->params[PARAM_MOD_KBD] * 8.0f - 4.0f;
   
   // ---- mod="kbd" input "off" seq 1/1
   
   // -- mod="0.0833333" dstVar=voice->tmp5_off
   voice->tmp5_off = 0.0833333f;
   voice->tmp6_scl = 4;
   out += (voice->note_cur + (voice->tmp5_off * 12.0f) - 64.0f) * voice->tmp4_kbd;
   #ifdef OVERSAMPLE_FACTOR
   out = ((440.0f/32.0f)*expf( ((out-9.0f)/12.0f)*logf(2.0f) )) / (voice->sample_rate * OVERSAMPLE_FACTOR);
   #else
   out = ((440.0f/32.0f)*expf( ((out-9.0f)/12.0f)*logf(2.0f) )) / voice->sample_rate;
   #endif
   out *= voice->tmp6_scl;
   
   // -- mod="sto v_mod_kbd" dstVar=out
   voice->var_v_mod_kbd = out;
   
   // -- mod="$m_mod_flt" dstVar=out
   out = voice->mod_mod_flt_cur;
   
   // -- mod="kbd" dstVar=out
   out *= 127.0f;
   
   // ---- mod="kbd" input "kbd" seq 1/1
   
   // -- mod="1" dstVar=voice->tmp7_kbd
   voice->tmp7_kbd = 1.0f;
   
   // ---- mod="kbd" input "off" seq 1/1
   
   // -- mod="0" dstVar=voice->tmp8_off
   voice->tmp8_off = 0.0f;
   voice->tmp9_scl = 4;
   out += (voice->note_cur + (voice->tmp8_off * 12.0f) - 64.0f) * voice->tmp7_kbd;
   out = clamp(out, 0.0f, 127.0f);
   #ifdef OVERSAMPLE_FACTOR
   out = ((440.0f/32.0f)*expf( ((out-9.0f)/12.0f)*logf(2.0f) )) / (voice->sample_rate * OVERSAMPLE_FACTOR);
   #else
   out = ((440.0f/32.0f)*expf( ((out-9.0f)/12.0f)*logf(2.0f) )) / voice->sample_rate;
   #endif
   out *= voice->tmp9_scl;
   
   // -- mod="sto v_mod_flt" dstVar=out
   voice->var_v_mod_flt = out;
} /* end prepare */

static unsigned int loc_copy_chars(char *_d, const unsigned int _dSize, const char *_s) {
   unsigned int r = 0u;
   if(NULL != _d)
   {
      // Write min(dSize,len(s)) characters to 'd'
      char *d = _d;
      if(NULL != _s)
      {
         const char *s = _s;
         for(;;)
         {
            if(r < _dSize)
            {
               char c = s[r++];
               *d++ = c;
               if(0 == c)
                  break;
            }
            else
            {
               if(r > 0u)
                  d[-1] = 0;  // force ASCIIZ
               break;
            }
         }
      }
      else
      {
         if(_dSize > 0u)
         {
            _d[0] = 0;
            r = 1u;
         }
      }
   }
   else
   {
      // Return total length of source string
      if(NULL != _s)
      {
         const char *s = _s;
         for(;;)
         {
            char c = s[r++];
            if(0 == c)
               break;
         }
      }
   }
   return r;
}

static unsigned int loc_copy_floats(float              *_d,
                                    const unsigned int  _dSize,
                                    const float        *_s,
                                    const unsigned int  _sNum
                                    ) {
   unsigned int r = 0u;
   if(NULL != _d)
   {
      // Write min(dSize,sNum) characters to 'd'
      if(NULL != _s)
      {
         unsigned int num = (_sNum > _dSize) ? _dSize : _sNum;
         memcpy((void*)_d, (const void*)_s, num * sizeof(float));
         r = num;
      }
   }
   else
   {
      // Query total number of presets
      r = _sNum;
   }
   return r;
}

static const char *ST_PLUGIN_API loc_get_param_name(st_plugin_info_t *_info,
                                                    unsigned int      _paramIdx
                                                    ) {
   (void)_info;
   return loc_param_names[_paramIdx];
}

static const char *ST_PLUGIN_API loc_get_param_group_name(st_plugin_info_t *_info,
                                                          unsigned int      _paramGroupIdx
                                                          ) {
   (void)_info;
   const char *r = NULL;
   static const char *groupNames[5] = { "shape", "freq", "amp", "kbd", "filter" };
   if(_paramGroupIdx < 5u)
      r = groupNames[_paramGroupIdx];
   return r;
}

static unsigned int ST_PLUGIN_API loc_get_param_group_idx(st_plugin_info_t *_info,
                                                          unsigned int      _paramIdx
                                                          ) {
   (void)_info;
   unsigned int r = ~0u;
   static unsigned int groupIndices[NUM_PARAMS] = { 0, 1, 0, 1, 2, 3, 3, 4 };
   r = groupIndices[_paramIdx];
   return r;
}

static float ST_PLUGIN_API loc_get_param_reset(st_plugin_info_t *_info,
                                               unsigned int      _paramIdx
                                               ) {
   (void)_info;
   return loc_param_resets[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_value(st_plugin_shared_t *_shared,
                                               unsigned int        _paramIdx
                                               ) {
   ST_PLUGIN_SHARED_CAST(aon_fm_v1_lofi_shared_t);
   return shared->params[_paramIdx];
}

static void ST_PLUGIN_API loc_set_param_value(st_plugin_shared_t *_shared,
                                              unsigned int        _paramIdx,
                                              float               _value
                                              ) {
   ST_PLUGIN_SHARED_CAST(aon_fm_v1_lofi_shared_t);
   shared->params[_paramIdx] = _value;
}

static unsigned int ST_PLUGIN_API loc_query_dynamic_param_preset_values(st_plugin_shared_t *_shared,
                                                                        const unsigned int  _paramIdx,
                                                                        float              *_retValues,
                                                                        const unsigned int  _retValuesSize
                                                                        ) {
   ST_PLUGIN_SHARED_CAST(aon_fm_v1_lofi_shared_t);
   unsigned int r = 0u;
   if(PARAM_CARRIER_WAVE == _paramIdx)
   {
      static const float presetValues_0[12] = { 0.0f, 0.090909f, 0.181818f, 0.272727f, 0.363636f, 0.454545f, 0.545454f, 0.636363f, 0.727272f, 0.818181f, 0.90909f, 1.0f };
      r = loc_copy_floats(_retValues, _retValuesSize, presetValues_0, 12);
   }
   if(PARAM_MOD_WAVE == _paramIdx)
   {
      static const float presetValues_2[12] = { 0.0f, 0.090909f, 0.181818f, 0.272727f, 0.363636f, 0.454545f, 0.545454f, 0.636363f, 0.727272f, 0.818181f, 0.90909f, 1.0f };
      r = loc_copy_floats(_retValues, _retValuesSize, presetValues_2, 12);
   }

   return r;
}

static unsigned int ST_PLUGIN_API loc_query_dynamic_param_preset_name(st_plugin_shared_t *_shared,
                                                                      const unsigned int  _paramIdx,
                                                                      const unsigned int  _presetIdx,
                                                                      char               *_retBuf,
                                                                      const unsigned int  _retBufSize
                                                                      ) {
   ST_PLUGIN_SHARED_CAST(aon_fm_v1_lofi_shared_t);
   unsigned int r = 0u;
   if(PARAM_CARRIER_WAVE == _paramIdx)
   {
      static const char *presetName_0[12] = { "Sinus", "Triangle", "Turnpoint", "Parabola", "Extremes", "Up&Down", "LineMix", "M-Shape", "Heart", "Sawtooth", "Sample", "DoubleSinus" };
      r = loc_copy_chars(_retBuf, _retBufSize, presetName_0[_presetIdx]);
   }
   if(PARAM_MOD_WAVE == _paramIdx)
   {
      static const char *presetName_2[12] = { "Sinus", "Triangle", "Turnpoint", "Parabola", "Extremes", "Up&Down", "LineMix", "M-Shape", "Heart", "Sawtooth", "Sample", "DoubleSinus" };
      r = loc_copy_chars(_retBuf, _retBufSize, presetName_2[_presetIdx]);
   }

   return r;
}

static const char *ST_PLUGIN_API loc_get_mod_name(st_plugin_info_t *_info,
                                                  unsigned int      _modIdx
                                                  ) {
   (void)_info;
   return loc_mod_names[_modIdx];
}

static void ST_PLUGIN_API loc_set_sample_rate(st_plugin_voice_t *_voice,
                                              float              _sampleRate
                                              ) {
   ST_PLUGIN_VOICE_CAST(aon_fm_v1_lofi_voice_t);
   voice->sample_rate = _sampleRate;
}

static void ST_PLUGIN_API loc_note_on(st_plugin_voice_t  *_voice,
                                      int                 _bGlide,
                                      unsigned char       _note,
                                      float               _vel
                                      ) {
   ST_PLUGIN_VOICE_CAST(aon_fm_v1_lofi_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(aon_fm_v1_lofi_shared_t);
   (void)_bGlide;
   (void)_note;
   (void)_vel;
   if(!_bGlide)
   {
      memset((void*)voice->mods, 0, sizeof(voice->mods));
#ifdef OVERSAMPLE_FACTOR
      voice->note_speed_fixed = (0.5f / (voice->sample_rate * OVERSAMPLE_FACTOR));
#else
      voice->note_speed_fixed = (0.5f / voice->sample_rate);
#endif // OVERSAMPLE_FACTOR
   int tmp11_zlp_pos;
   int tmp21_zlp_pos;


      voice->tmp11_zlp_pos = 0;
      voice->tmp21_zlp_pos = 0;
      voice->tmp31_svf_lp = 0;
      voice->tmp32_svf_hp = 0;
      voice->tmp33_svf_bp = 0;
      voice->tmp39_flt_last = 0.0f;

      voice->var_x = 0.0f;
      voice->var_v_carrier_kbd = 0.0f;
      voice->var_v_mod_kbd = 0.0f;
      voice->var_v_mod_flt = 0.0f;


   }
}

static void ST_PLUGIN_API loc_set_mod_value(st_plugin_voice_t *_voice,
                                            unsigned int       _modIdx,
                                            float              _value,
                                            unsigned           _frameOffset
                                            ) {
   ST_PLUGIN_VOICE_CAST(aon_fm_v1_lofi_voice_t);
   (void)_frameOffset;
   voice->mods[_modIdx] = _value;
}

static void ST_PLUGIN_API loc_prepare_block(st_plugin_voice_t *_voice,
                                            unsigned int       _numFrames,
                                            float              _freqHz,
                                            float              _note,
                                            float              _vol,
                                            float              _pan
                                            ) {
   ST_PLUGIN_VOICE_CAST(aon_fm_v1_lofi_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(aon_fm_v1_lofi_shared_t);
   (void)_note;
   (void)_vol;
   (void)_pan;

#ifdef OVERSAMPLE_FACTOR
   float noteSpeed = _freqHz / (voice->sample_rate * OVERSAMPLE_FACTOR);
#else
   float noteSpeed = _freqHz / voice->sample_rate;
#endif // OVERSAMPLE_FACTOR

   float modcarrier_wave = shared->params[PARAM_CARRIER_WAVE] * 11.0f               + voice->mods[MOD_CARRIER_WAVE ];
   float modcarrier_freq = shared->params[PARAM_CARRIER_FREQ] * 2.0f - 1.0f         + voice->mods[MOD_CARRIER_FREQ ];
   float modmod_wave     = shared->params[PARAM_MOD_WAVE    ] * 11.0f               + voice->mods[MOD_MOD_WAVE     ];
   float modmod_freq     = shared->params[PARAM_MOD_FREQ    ] * 2.0f - 1.0f         + voice->mods[MOD_MOD_FREQ     ];
   float modmod_amp      = shared->params[PARAM_MOD_AMP     ] * 32.0f - 16.0f       + voice->mods[MOD_MOD_AMP      ];
   float modmod_flt      = shared->params[PARAM_MOD_FLT     ]                       + voice->mods[MOD_MOD_FLT      ];

   if(_numFrames > 0u)
   {
      // lerp
      float recBlockSize = (1.0f / _numFrames);
      voice->note_speed_inc = (noteSpeed - voice->note_speed_cur) * recBlockSize;
      voice->note_inc       = (_note - voice->note_cur) * recBlockSize;
      voice->mod_carrier_wave_inc = (modcarrier_wave    - voice->mod_carrier_wave_cur  ) * recBlockSize;
      voice->mod_carrier_freq_inc = (modcarrier_freq    - voice->mod_carrier_freq_cur  ) * recBlockSize;
      voice->mod_mod_wave_inc     = (modmod_wave        - voice->mod_mod_wave_cur      ) * recBlockSize;
      voice->mod_mod_freq_inc     = (modmod_freq        - voice->mod_mod_freq_cur      ) * recBlockSize;
      voice->mod_mod_amp_inc      = (modmod_amp         - voice->mod_mod_amp_cur       ) * recBlockSize;
      voice->mod_mod_flt_inc      = (modmod_flt         - voice->mod_mod_flt_cur       ) * recBlockSize;

      loc_prepare(&voice->base);
   }
   else
   {
      // initial params/modulation (first block, not rendered)
      voice->note_speed_cur = noteSpeed;
      voice->note_speed_inc = 0.0f;
      voice->note_cur       = _note;
      voice->note_inc       = 0.0f;
      voice->mod_carrier_wave_cur = modcarrier_wave;
      voice->mod_carrier_wave_inc = 0.0f;
      voice->mod_carrier_freq_cur = modcarrier_freq;
      voice->mod_carrier_freq_inc = 0.0f;
      voice->mod_mod_wave_cur     = modmod_wave;
      voice->mod_mod_wave_inc     = 0.0f;
      voice->mod_mod_freq_cur     = modmod_freq;
      voice->mod_mod_freq_inc     = 0.0f;
      voice->mod_mod_amp_cur      = modmod_amp;
      voice->mod_mod_amp_inc      = 0.0f;
      voice->mod_mod_flt_cur      = modmod_flt;
      voice->mod_mod_flt_inc      = 0.0f;

      loc_prepare(&voice->base);
   }

   // printf("xxx note_cur=%f\n", voice->note_cur);
}

static void ST_PLUGIN_API loc_process_replace(st_plugin_voice_t  *_voice,
                                              int                 _bMonoIn,
                                              const float        *_samplesIn,
                                              float              *_samplesOut, 
                                              unsigned int        _numFrames
                                              ) {
   (void)_bMonoIn;
   (void)_samplesIn;

   ST_PLUGIN_VOICE_CAST(aon_fm_v1_lofi_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(aon_fm_v1_lofi_shared_t);

   // Mono output (replicate left to right channel)
   unsigned int j = 0u;
   unsigned int jStep = _bMonoIn ? 1u : 2u;
   unsigned int k = 0u;
   for(unsigned int i = 0u; i < _numFrames; i++)
   {
      float out = _samplesIn[j];
      j += jStep;
#ifdef OVERSAMPLE_FACTOR
      float outOS = 0.0f;
#endif // OVERSAMPLE_FACTOR

#ifdef OVERSAMPLE_FACTOR
      for(unsigned int osi = 0u; osi < OVERSAMPLE_FACTOR; osi++)
#endif // OVERSAMPLE_FACTOR
      {
      float tmp_f;
      float tmp2_f;
      
      // ========
      // ======== lane "out" modIdx=0
      // ========
      
      // -- mod="int" dstVar=out
      voice->tmp10_out_i = (short)(out * 2048);
      {
      
      // -- mod="zlp" dstVar=voice->tmp10_out_i
      
      // ---- mod="zlp " input "sub" seq 1/1
      
      // -- mod="$m_carrier_wave" dstVar=voice->tmp12_zlp_sub_off_x
      voice->tmp13_f2i = (float)(voice->tmp12_zlp_sub_off_x) / 2048;  // FloatFallback: I2F
      voice->tmp13_f2i = voice->mod_carrier_wave_cur;
      voice->tmp12_zlp_sub_off_x = (int)(voice->tmp13_f2i * 2048);  // FloatFallback: F2I
      int tmp14_zlp_sub_off;
      tmp14_zlp_sub_off = Dmulsw_shr(voice->tmp12_zlp_sub_off_x, 128);
      if((tmp14_zlp_sub_off + 128) > 1536)
         tmp14_zlp_sub_off = 1408;
      else if(tmp14_zlp_sub_off < 0)
         tmp14_zlp_sub_off = 0;
      voice->tmp10_out_i = (short)(loc_smp_aon_fm_oscwaves_zone0[tmp14_zlp_sub_off+((voice->tmp11_zlp_pos >> 16) & 127)] * 2048);
      
      // ---- mod="zlp " input "rate" seq 1/1
      
      // -- mod="$p_carrier_freq" dstVar=voice->tmp15_rate
      voice->tmp16_f2i = (float)(voice->tmp15_rate) / 2048;  // FloatFallback: I2F
      voice->tmp16_f2i = shared->params[PARAM_CARRIER_FREQ] * 2.0f - 1.0f;
      voice->tmp15_rate = (int)(voice->tmp16_f2i * 2048);  // FloatFallback: F2I
      
      // -- mod="$m_carrier_freq" dstVar=voice->tmp15_rate
      voice->tmp18_f2i = (float)(voice->tmp17_seq) / 2048;  // FloatFallback: I2F
      voice->tmp18_f2i = voice->mod_carrier_freq_cur;
      voice->tmp17_seq = (int)(voice->tmp18_f2i * 2048);  // FloatFallback: F2I
      voice->tmp15_rate += voice->tmp17_seq;
      
      // -- mod="bts" dstVar=voice->tmp15_rate
      voice->tmp19_f2i = (float)(voice->tmp15_rate) / 2048;  // FloatFallback: I2F
      voice->tmp19_f2i = loc_bipolar_to_scale(voice->tmp19_f2i, 16.0f, 16.0f);
      voice->tmp15_rate = (int)(voice->tmp19_f2i * 2048);  // FloatFallback: F2I
      
      // -- mod="zlp" dstVar=voice->tmp15_rate
      
      // ---- mod="zlp " input "sub" seq 1/1
      
      // -- mod="$m_mod_wave" dstVar=voice->tmp22_zlp_sub_off_x
      voice->tmp23_f2i = (float)(voice->tmp22_zlp_sub_off_x) / 2048;  // FloatFallback: I2F
      voice->tmp23_f2i = voice->mod_mod_wave_cur;
      voice->tmp22_zlp_sub_off_x = (int)(voice->tmp23_f2i * 2048);  // FloatFallback: F2I
      int tmp24_zlp_sub_off;
      tmp24_zlp_sub_off = Dmulsw_shr(voice->tmp22_zlp_sub_off_x, 128);
      if((tmp24_zlp_sub_off + 128) > 1536)
         tmp24_zlp_sub_off = 1408;
      else if(tmp24_zlp_sub_off < 0)
         tmp24_zlp_sub_off = 0;
      voice->tmp20_seq = (short)(loc_smp_aon_fm_oscwaves_zone0[tmp24_zlp_sub_off+((voice->tmp21_zlp_pos >> 16) & 127)] * 2048);
      
      // ---- mod="zlp " input "rate" seq 1/1
      
      // -- mod="$p_mod_freq" dstVar=voice->tmp25_rate
      voice->tmp26_f2i = (float)(voice->tmp25_rate) / 2048;  // FloatFallback: I2F
      voice->tmp26_f2i = shared->params[PARAM_MOD_FREQ] * 2.0f - 1.0f;
      voice->tmp25_rate = (int)(voice->tmp26_f2i * 2048);  // FloatFallback: F2I
      
      // -- mod="$m_mod_freq" dstVar=voice->tmp25_rate
      voice->tmp28_f2i = (float)(voice->tmp27_seq) / 2048;  // FloatFallback: I2F
      voice->tmp28_f2i = voice->mod_mod_freq_cur;
      voice->tmp27_seq = (int)(voice->tmp28_f2i * 2048);  // FloatFallback: F2I
      voice->tmp25_rate += voice->tmp27_seq;
      
      // -- mod="bts" dstVar=voice->tmp25_rate
      voice->tmp29_f2i = (float)(voice->tmp25_rate) / 2048;  // FloatFallback: I2F
      voice->tmp29_f2i = loc_bipolar_to_scale(voice->tmp29_f2i, 16.0f, 16.0f);
      voice->tmp25_rate = (int)(voice->tmp29_f2i * 2048);  // FloatFallback: F2I
      
      // -- mod="$v_mod_kbd" dstVar=voice->tmp25_rate
      voice->tmp30_seq = (short)(voice->var_v_mod_kbd * 2048);
      voice->tmp25_rate = mulsw(voice->tmp25_rate, voice->tmp30_seq) >> 11;
      voice->tmp21_zlp_pos += (voice->tmp25_rate << 5);
      
      // -- mod="svf" dstVar=voice->tmp20_seq
      
      // ---- mod="svf " input "freq" seq 1/1
      
      // -- mod="$m_mod_flt" dstVar=voice->tmp34_freq
      voice->tmp35_f2i = (float)(voice->tmp34_freq) / 2048;  // FloatFallback: I2F
      voice->tmp35_f2i = voice->mod_mod_flt_cur;
      voice->tmp34_freq = (int)(voice->tmp35_f2i * 2048);  // FloatFallback: F2I
      voice->tmp31_svf_lp = voice->tmp31_svf_lp + (mulsw(voice->tmp33_svf_bp, voice->tmp34_freq) >> 11);
      voice->tmp32_svf_hp = voice->tmp20_seq - voice->tmp31_svf_lp - (mulsw(voice->tmp33_svf_bp, 2048) >> 11);
      voice->tmp33_svf_bp = voice->tmp33_svf_bp + (mulsw(voice->tmp32_svf_hp, voice->tmp34_freq) >> 11);
      voice->tmp20_seq = voice->tmp31_svf_lp;
      
      // -- mod="$m_mod_amp" dstVar=voice->tmp20_seq
      voice->tmp37_f2i = (float)(voice->tmp36_seq) / 2048;  // FloatFallback: I2F
      voice->tmp37_f2i = voice->mod_mod_amp_cur;
      voice->tmp36_seq = (int)(voice->tmp37_f2i * 2048);  // FloatFallback: F2I
      voice->tmp20_seq = mulsw(voice->tmp20_seq, voice->tmp36_seq) >> 11;
      voice->tmp15_rate += voice->tmp20_seq;
      
      // -- mod="$v_carrier_kbd" dstVar=voice->tmp15_rate
      voice->tmp38_seq = (short)(voice->var_v_carrier_kbd * 2048);
      voice->tmp15_rate = mulsw(voice->tmp15_rate, voice->tmp38_seq) >> 11;
      voice->tmp11_zlp_pos += (voice->tmp15_rate << 5);
      }
      out = voice->tmp10_out_i * 0.000488281;
      
      // -- mod="flt" dstVar=out
      out = mathLerpf(voice->tmp39_flt_last, out, 0.4096f);
      voice->tmp39_flt_last = out;

      /* end calc */

#ifdef OVERSAMPLE_FACTOR
         outOS += out;
#endif // OVERSAMPLE_FACTOR
      }
#ifdef OVERSAMPLE_FACTOR
      // Apply lowpass filter before downsampling
      //   (note) normalized Fc = F/Fs = 0.442947 / sqrt(oversample_factor - 1)
      out = outOS * (1.0f / OVERSAMPLE_FACTOR);
#endif // OVERSAMPLE_FACTOR
      _samplesOut[k]      = out;
      _samplesOut[k + 1u] = out;

      // Next frame
      k += 2u;
      voice->note_speed_cur += voice->note_speed_inc;
      voice->mod_carrier_wave_cur  += voice->mod_carrier_wave_inc;
      voice->mod_carrier_freq_cur  += voice->mod_carrier_freq_inc;
      voice->mod_mod_wave_cur      += voice->mod_mod_wave_inc;
      voice->mod_mod_freq_cur      += voice->mod_mod_freq_inc;
      voice->mod_mod_amp_cur       += voice->mod_mod_amp_inc;
      voice->mod_mod_flt_cur       += voice->mod_mod_flt_inc;
   } /* loop numFrames */
}

static st_plugin_shared_t *ST_PLUGIN_API loc_shared_new(st_plugin_info_t *_info) {
   aon_fm_v1_lofi_shared_t *ret = (aon_fm_v1_lofi_shared_t *)malloc(sizeof(aon_fm_v1_lofi_shared_t));
   if(NULL != ret)
   {
      memset((void*)ret, 0, sizeof(*ret));
      ret->base.info  = _info;
      memcpy((void*)ret->params, (void*)loc_param_resets, NUM_PARAMS * sizeof(float));
   }
   return &ret->base;
}

static void ST_PLUGIN_API loc_shared_delete(st_plugin_shared_t *_shared) {
   free((void*)_shared);
}

static st_plugin_voice_t *ST_PLUGIN_API loc_voice_new(st_plugin_info_t *_info) {
   aon_fm_v1_lofi_voice_t *voice = (aon_fm_v1_lofi_voice_t *)malloc(sizeof(aon_fm_v1_lofi_voice_t));
   if(NULL != voice)
   {
      memset((void*)voice, 0, sizeof(*voice));
      voice->base.info = _info;
      voice->tmp11_zlp_pos = 0;
      voice->tmp21_zlp_pos = 0;
   }
   return &voice->base;
}

static void ST_PLUGIN_API loc_voice_delete(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(aon_fm_v1_lofi_voice_t);

   free((void*)_voice);
}

static void ST_PLUGIN_API loc_plugin_exit(st_plugin_info_t *_info) {
   free((void*)_info);
}

#ifdef USE_CYCLE_SINE_TBL
static void loc_calc_sine_tbl(void) {
#define QCOS_BITS 16
#define QCOS_ONE  (1 << QCOS_BITS)
#define QCOS_MASK (QCOS_ONE - 1)
   // (note) same as in TSR "C" implementation
   float *qcos = cycle_sine_tbl_f + 4096; // quarter cos tbl

   // calc quarter cos tbl
   int k = 0;
   for(int a = 0; a < (QCOS_ONE/4); a += (QCOS_ONE/16384)/*4*/)  // 4096 elements
   {
      int x = a - ((int)(QCOS_ONE * 0.25 + 0.5)) + ((a + ((int)(QCOS_ONE * 0.25 + 0.5)))&~QCOS_MASK);
      x = ((x * ((x<0?-x:x) - ((int)(QCOS_ONE * 0.5 + 0.5)))) >> QCOS_BITS) << 4;
      x += (((((int)(QCOS_ONE * 0.225 + 0.5)) * x) >> QCOS_BITS) * ((x<0?-x:x) - QCOS_ONE)) >> QCOS_BITS;
      qcos[k++] = x / float(QCOS_ONE);
   }

   // 0..90 (rev qtbl)
   int j = 4096;
   k = 0;
   loop(4096)
      cycle_sine_tbl_f[k++] = qcos[--j];

   // 90..180 = cos tbl
   k += 4096;

   // 180..360 (y-flip first half of tbl)
   j = 0;
   loop(8192)
      cycle_sine_tbl_f[k++] = -cycle_sine_tbl_f[j++];

#ifdef USE_CYCLE_SINE_TBL_I
   loop(16384)
      cycle_sine_tbl_i[i] = (short)(cycle_sine_tbl_f[i] * 2048.0f/*FX_ONE*/);
#endif // USE_CYCLE_SINE_TBL_I
}
#endif // USE_CYCLE_SINE_TBL

extern "C" {
st_plugin_info_t *aon_fm_v1_lofi_init(void) {
   aon_fm_v1_lofi_info_t *ret = (aon_fm_v1_lofi_info_t *)malloc(sizeof(aon_fm_v1_lofi_info_t));

   if(NULL != ret)
   {
      memset(ret, 0, sizeof(*ret));

      ret->base.api_version = ST_PLUGIN_API_VERSION;
      ret->base.id          = "aon_fm_v1_lofi";  // unique id. don't change this in future builds.
      ret->base.author      = "bsp";
      ret->base.name        = "aon_fm_v1_lofi";
      ret->base.short_name  = "aon_fm_v1_lofi";
      ret->base.flags       = ST_PLUGIN_FLAG_OSC;
      ret->base.category    = ST_PLUGIN_CAT_UNKNOWN;
      ret->base.num_params  = NUM_PARAMS;
      ret->base.num_mods    = NUM_MODS;

      ret->base.shared_new                        = &loc_shared_new;
      ret->base.shared_delete                     = &loc_shared_delete;
      ret->base.voice_new                         = &loc_voice_new;
      ret->base.voice_delete                      = &loc_voice_delete;
      ret->base.get_param_name                    = &loc_get_param_name;
      ret->base.get_param_group_name              = &loc_get_param_group_name;
      ret->base.get_param_group_idx               = &loc_get_param_group_idx;
      ret->base.get_param_reset                   = &loc_get_param_reset;
      ret->base.query_dynamic_param_preset_values = &loc_query_dynamic_param_preset_values;
      ret->base.query_dynamic_param_preset_name   = &loc_query_dynamic_param_preset_name;
      ret->base.get_param_value                   = &loc_get_param_value;
      ret->base.set_param_value                   = &loc_set_param_value;
      ret->base.get_mod_name                      = &loc_get_mod_name;
      ret->base.set_sample_rate                   = &loc_set_sample_rate;
      ret->base.note_on                           = &loc_note_on;
      ret->base.set_mod_value                     = &loc_set_mod_value;
      ret->base.prepare_block                     = &loc_prepare_block;
      ret->base.process_replace                   = &loc_process_replace;
      ret->base.plugin_exit                       = &loc_plugin_exit;

#ifdef USE_CYCLE_SINE_TBL
      loc_calc_sine_tbl();
#endif // USE_CYCLE_SINE_TBL
   }

   return &ret->base;
}

#ifndef STFX_SKIP_MAIN_INIT
ST_PLUGIN_APICALL st_plugin_info_t *ST_PLUGIN_API st_plugin_init(unsigned int _pluginIdx) {
   switch(_pluginIdx)
   {
      case 0u:
         return aon_fm_v1_lofi_init();
   }
   return NULL;
}
#endif // STFX_SKIP_MAIN_INIT

} // extern "C"
