// ----
// ---- file   : inv_lut_osc_1.cpp
// ---- author : bsp
// ---- legal  : Distributed under terms of the MIT license (https://opensource.org/licenses/MIT)
// ----
// ----          Permission is hereby granted, free of charge, to any person obtaining a copy of this software and 
// ----          associated documentation files (the "Software"), to deal in the Software without restriction, including 
// ----          without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// ----          copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to 
// ----          the following conditions:
// ----  
// ----          The above copyright notice and this permission notice shall be included in all copies or substantial 
// ----          portions of the Software.
// ----
// ----          THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
// ----          NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// ----          IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// ----          WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// ----          SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// ----
// ---- info   : auto-generated by "Cycle"
// ----           $ g++ -Wall -Wno-unused-function -Wno-unused-variable -I../../tksampler -c inv_lut_osc_1.cpp -o inv_lut_osc_1.o
// ---- created: 08Aug2023 12:35:54
// ----
// ----
// ----

#include <plugin.h>

#include <stdlib.h>
#include <math.h>
#include <string.h>




#define PARAM_RES                0
#define PARAM_CUTOFF             1
#define PARAM_EXP                2
#define NUM_PARAMS               3
static const char *loc_param_names[NUM_PARAMS] = {
   "res",                     // 0: RES
   "cutoff",                  // 1: CUTOFF
   "exp",                     // 2: EXP

};
static float loc_param_resets[NUM_PARAMS] = {
   0.5f,                      // 0: RES
   0.4f,                      // 1: CUTOFF
   5.0f,                      // 2: EXP

};

#define MOD_CUTOFF               0
#define MOD_RES                  1
#define MOD_EXP                  2
#define NUM_MODS                 3
static const char *loc_mod_names[NUM_MODS] = {
   "cutoff",       // 0: CUTOFF
   "res",          // 1: RES
   "exp",          // 2: EXP

};

typedef struct inv_lut_osc_1_info_s {
   st_plugin_info_t base;
} inv_lut_osc_1_info_t;

typedef struct inv_lut_osc_1_shared_s {
   st_plugin_shared_t base;
   float params[NUM_PARAMS];

} inv_lut_osc_1_shared_t;

typedef struct inv_lut_osc_1_voice_s {
   st_plugin_voice_t base;
   float             sample_rate;
   float             note_speed_fixed;
   float             note_speed_cur;
   float             note_speed_inc;
   float             note_cur;
   float             note_inc;
   float             mods[NUM_MODS];
   float mod_cutoff_cur;
   float mod_cutoff_inc;
   float mod_res_cur;
   float mod_res_inc;
   float mod_exp_cur;
   float mod_exp_inc;

   float tmp1_exp;
   float tmp2_exp;
   float tmp3_div_a;
   float tmp4_div_b;
   float tmp5_kbd;
   float tmp6_off;
   float tmp7_scl;
   float tmp8_saw_phase;
   float tmp9_saw_speed;
   float tmp10_freq;
   float tmp11_saw_tmp;
   float tmp12_svf_lp;
   float tmp13_svf_hp;
   float tmp14_svf_bp;
   float tmp15_res;
   float tmp16_freq;
   float tmp17_svf_lp;
   float tmp18_svf_hp;
   float tmp19_svf_bp;
   float tmp20_res;
   float tmp21_freq;
   float var_x;
   float var_v_cutoff;

   float lut_ws[4096];
   float lut_ws_inv[4096];

} inv_lut_osc_1_voice_t;

#define loop(X)  for(unsigned int i = 0u; i < (X); i++)
#define clamp(a,b,c) (((a)<(b))?(b):(((a)>(c))?(c):(a)))

static inline float mathLerpf(float _a, float _b, float _t) { return _a + (_b - _a) * _t; }
static inline float mathClampf(float a, float b, float c) { return (((a)<(b))?(b):(((a)>(c))?(c):(a))); }
static inline float mathMinf(float a, float b) { return (a<b)?a:b; }
static inline float mathMaxf(float a, float b) { return (a>b)?a:b; }
static inline float mathAbsMaxf(float _x, float _y) { return ( ( (_x<0.0f)?-_x:_x)>((_y<0.0f)?-_y:_y)?_x:_y ); }
static inline float mathAbsMinf(float _x, float _y) { return ( ((_x<0.0f)?-_x:_x)<((_y<0.0f)?-_y:_y)?_x:_y ); }

static inline float winLinear(const float *_s, float _index) {
   int idx = (int)_index;
   float r = _index - (float)idx;
   return mathLerpf(_s[idx], _s[idx+1], r);
}

static float ffrac_s(float _f) { int i; if(_f >= 0.0f) { i = (int)_f; return _f - (float)i; } else { i = (int)-_f; return 1.0f - (-_f - (float)i); } }

static float mathPowerf(float _x, float _y) {
   float r;
   if(_y != 0.0f)
   {
      if(_x < 0.0f)
      {
         r = (float)( -expf(_y*logf(-_x)) );
      }
      else if(_x > 0.0f)
      {
         r = (float)( expf(_y*logf(_x)) );
      }
      else
      {
         r = 0.0f;
      }
   }
   else
   {
      r = 1.0f;
   }
   return Dstplugin_fix_denorm_32(r);
}

static void loc_update_lut_ws(st_plugin_voice_t *_voice, float *_d);
static void loc_update_lut_ws_inv(st_plugin_voice_t *_voice, float *_d);
static void loc_prepare(st_plugin_voice_t *_voice);

void loc_update_lut_ws(st_plugin_voice_t *_voice, float *_d) {
   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(inv_lut_osc_1_shared_t);
   float x = 0.0f;
   loop(4096)
   {
      float out = x;
      // -------- lane "lut_ws" modIdx=0
      
      // -- mod="fma" dstVar=out
      out = (out * 2.0f) + -1.0f;
      
      // -- mod="pow" dstVar=out
      
      // ---- mod="pow" input "exp" seq 1/1
      
      // -- mod="$m_exp" dstVar=voice->tmp1_exp
      voice->tmp1_exp = voice->mod_exp_cur;
      out = mathPowerf(out, voice->tmp1_exp);
      _d[i] = out;

      // Next x
      x += 0.0002442f;
   } // loop 4096
} /* end loc_update_lut_ws() */

void loc_update_lut_ws_inv(st_plugin_voice_t *_voice, float *_d) {
   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(inv_lut_osc_1_shared_t);
   float x = 0.0f;
   loop(4096)
   {
      float out = x;
      // -------- lane "lut_ws_inv" modIdx=0
      
      // -- mod="fma" dstVar=out
      out = (out * 2.0f) + -1.0f;
      
      // -- mod="pow" dstVar=out
      
      // ---- mod="pow" input "exp" seq 1/1
      
      // -- mod="div" dstVar=voice->tmp2_exp
      
      // ---- mod="div" input "a" seq 1/1
      
      // -- mod="1" dstVar=voice->tmp3_div_a
      voice->tmp3_div_a = 1.0f;
      
      // ---- mod="div" input "b" seq 1/1
      
      // -- mod="$m_exp" dstVar=voice->tmp4_div_b
      voice->tmp4_div_b = voice->mod_exp_cur;
      voice->tmp2_exp = (0.0f != voice->tmp4_div_b) ? (voice->tmp3_div_a / voice->tmp4_div_b) : 0.0f;
      out = mathPowerf(out, voice->tmp2_exp);
      _d[i] = out;

      // Next x
      x += 0.0002442f;
   } // loop 4096
} /* end loc_update_lut_ws_inv() */

void loc_prepare(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(inv_lut_osc_1_shared_t);

   float out = 0.0f;
   // -------- lane "prepare" modIdx=0
   
   // -- mod="$m_cutoff" dstVar=out
   out = voice->mod_cutoff_cur;
   
   // -- mod="kbd" dstVar=out
   out *= 127.0f;
   
   // ---- mod="kbd" input "kbd" seq 1/1
   
   // -- mod="$P_FLTKBDAMT" dstVar=voice->tmp5_kbd
   voice->tmp5_kbd = 0.25f;
   
   // ---- mod="kbd" input "off" seq 1/1
   
   // -- mod="0" dstVar=voice->tmp6_off
   voice->tmp6_off = 0.0f;
   voice->tmp7_scl = 4;
   out += (voice->note_cur + (voice->tmp6_off * 12.0f) - 64.0f) * voice->tmp5_kbd;
   out = clamp(out, 0.0f, 127.0f);
   #ifdef OVERSAMPLE_FACTOR
   out = ((440.0f/32.0f)*expf( ((out-9.0f)/12.0f)*logf(2.0f) )) / (voice->sample_rate * OVERSAMPLE_FACTOR);
   #else
   out = ((440.0f/32.0f)*expf( ((out-9.0f)/12.0f)*logf(2.0f) )) / voice->sample_rate;
   #endif
   out *= voice->tmp7_scl;
   
   // -- mod="sto v_cutoff" dstVar=out
   voice->var_v_cutoff = out;
} /* end prepare */

static const char *ST_PLUGIN_API loc_get_param_name(st_plugin_info_t *_info,
                                                    unsigned int      _paramIdx
                                                    ) {
   (void)_info;
   return loc_param_names[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_reset(st_plugin_info_t *_info,
                                               unsigned int      _paramIdx
                                               ) {
   (void)_info;
   return loc_param_resets[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_value(st_plugin_shared_t *_shared,
                                               unsigned int        _paramIdx
                                               ) {
   ST_PLUGIN_SHARED_CAST(inv_lut_osc_1_shared_t);
   return shared->params[_paramIdx];
}

static void ST_PLUGIN_API loc_set_param_value(st_plugin_shared_t *_shared,
                                              unsigned int        _paramIdx,
                                              float               _value
                                              ) {
   ST_PLUGIN_SHARED_CAST(inv_lut_osc_1_shared_t);
   shared->params[_paramIdx] = _value;
}

static const char *ST_PLUGIN_API loc_get_mod_name(st_plugin_info_t *_info,
                                                  unsigned int      _modIdx
                                                  ) {
   (void)_info;
   return loc_mod_names[_modIdx];
}

static void ST_PLUGIN_API loc_set_sample_rate(st_plugin_voice_t *_voice,
                                              float              _sampleRate
                                              ) {
   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);
   voice->sample_rate = _sampleRate;
}

static void ST_PLUGIN_API loc_note_on(st_plugin_voice_t  *_voice,
                                      int                 _bGlide,
                                      unsigned char       _note,
                                      float               _vel
                                      ) {
   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(inv_lut_osc_1_shared_t);
   (void)_bGlide;
   (void)_note;
   (void)_vel;
   if(!_bGlide)
   {
      memset((void*)voice->mods, 0, sizeof(voice->mods));
#ifdef OVERSAMPLE_FACTOR
      voice->note_speed_fixed = (0.5f / (voice->sample_rate * OVERSAMPLE_FACTOR));
#else
      voice->note_speed_fixed = (0.5f / voice->sample_rate);
#endif // OVERSAMPLE_FACTOR


      voice->tmp8_saw_phase = 0.0f;
      voice->tmp12_svf_lp = 0.0f;
      voice->tmp13_svf_hp = 0.0f;
      voice->tmp14_svf_bp = 0.0f;
      voice->tmp17_svf_lp = 0.0f;
      voice->tmp18_svf_hp = 0.0f;
      voice->tmp19_svf_bp = 0.0f;

      voice->var_x = 0.0f;
      voice->var_v_cutoff = 0.0f;


   }
}

static void ST_PLUGIN_API loc_set_mod_value(st_plugin_voice_t *_voice,
                                            unsigned int       _modIdx,
                                            float              _value,
                                            unsigned           _frameOffset
                                            ) {
   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);
   (void)_frameOffset;
   voice->mods[_modIdx] = _value;
}

static void ST_PLUGIN_API loc_prepare_block(st_plugin_voice_t *_voice,
                                            unsigned int       _numFrames,
                                            float              _freqHz,
                                            float              _note,
                                            float              _vol,
                                            float              _pan
                                            ) {
   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(inv_lut_osc_1_shared_t);
   (void)_note;
   (void)_vol;
   (void)_pan;

#ifdef OVERSAMPLE_FACTOR
   float noteSpeed = _freqHz / (voice->sample_rate * OVERSAMPLE_FACTOR);
#else
   float noteSpeed = _freqHz / voice->sample_rate;
#endif // OVERSAMPLE_FACTOR

   float modcutoff       = shared->params[PARAM_CUTOFF      ]                       + voice->mods[MOD_CUTOFF       ];
   float modres          = shared->params[PARAM_RES         ]                       + voice->mods[MOD_RES          ];
   float modexp          = shared->params[PARAM_EXP         ] * 14.0f + 1.0f        + voice->mods[MOD_EXP          ];

   if(_numFrames > 0u)
   {
      // lerp
      float recBlockSize = (1.0f / _numFrames);
      voice->note_speed_inc = (noteSpeed - voice->note_speed_cur) * recBlockSize;
      voice->note_inc       = (_note - voice->note_cur) * recBlockSize;
      voice->mod_cutoff_inc       = (modcutoff          - voice->mod_cutoff_cur        ) * recBlockSize;
      voice->mod_res_inc          = (modres             - voice->mod_res_cur           ) * recBlockSize;
      voice->mod_exp_inc          = (modexp             - voice->mod_exp_cur           ) * recBlockSize;

      loc_prepare(&voice->base);
   }
   else
   {
      // initial params/modulation (first block, not rendered)
      voice->note_speed_cur = noteSpeed;
      voice->note_speed_inc = 0.0f;
      voice->note_cur       = _note;
      voice->note_inc       = 0.0f;
      voice->mod_cutoff_cur       = modcutoff;
      voice->mod_cutoff_inc       = 0.0f;
      voice->mod_res_cur          = modres;
      voice->mod_res_inc          = 0.0f;
      voice->mod_exp_cur          = modexp;
      voice->mod_exp_inc          = 0.0f;

      loc_prepare(&voice->base);   
      loc_update_lut_ws(&voice->base, voice->lut_ws);
      loc_update_lut_ws_inv(&voice->base, voice->lut_ws_inv);

   }

   // printf("xxx note_cur=%f\n", voice->note_cur);
}

static void ST_PLUGIN_API loc_process_replace(st_plugin_voice_t  *_voice,
                                              int                 _bMonoIn,
                                              const float        *_samplesIn,
                                              float              *_samplesOut, 
                                              unsigned int        _numFrames
                                              ) {
   (void)_bMonoIn;
   (void)_samplesIn;

   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(inv_lut_osc_1_shared_t);

   // Mono output (replicate left to right channel)
   unsigned int j = 0u;
   unsigned int jStep = _bMonoIn ? 1u : 2u;
   unsigned int k = 0u;
   for(unsigned int i = 0u; i < _numFrames; i++)
   {
      float out = _samplesIn[j];
      j += jStep;
#ifdef OVERSAMPLE_FACTOR
      float outOS = 0.0f;
#endif // OVERSAMPLE_FACTOR

#ifdef OVERSAMPLE_FACTOR
      for(unsigned int osi = 0u; osi < OVERSAMPLE_FACTOR; osi++)
#endif // OVERSAMPLE_FACTOR
      {
      float tmp_f;
      float tmp2_f;
      
      // ========
      // ======== lane "out" modIdx=0
      // ========
      
      // -- mod="saw" dstVar=out
      voice->tmp10_freq = 1;
      voice->tmp9_saw_speed = voice->note_speed_cur * voice->tmp10_freq;
      voice->tmp11_saw_tmp = (voice->tmp8_saw_phase);
      voice->tmp11_saw_tmp = ffrac_s(voice->tmp11_saw_tmp);
      out = 1.0 - (voice->tmp11_saw_tmp * 2.0f);
      voice->tmp8_saw_phase = ffrac_s(voice->tmp8_saw_phase + voice->tmp9_saw_speed);
      
      // -- mod="fma" dstVar=out
      out = (out * 0.49f) + 0.5f;
      
      // -- mod="lut" dstVar=out
      out = voice->lut_ws[((unsigned int)(out * 4095)) & 4095];
      
      // -- mod="svf" dstVar=out
      
      // ---- mod="svf" input "res" seq 1/1
      
      // -- mod="$m_res" dstVar=voice->tmp15_res
      voice->tmp15_res = voice->mod_res_cur;
      
      // ---- mod="svf" input "freq" seq 1/1
      
      // -- mod="$v_cutoff" dstVar=voice->tmp16_freq
      voice->tmp16_freq = voice->var_v_cutoff;
      voice->tmp12_svf_lp = voice->tmp12_svf_lp + (voice->tmp14_svf_bp * voice->tmp16_freq);
      voice->tmp13_svf_hp = out - voice->tmp12_svf_lp - (voice->tmp14_svf_bp * voice->tmp15_res);
      voice->tmp14_svf_bp = voice->tmp14_svf_bp + (voice->tmp13_svf_hp * voice->tmp16_freq);
      out = voice->tmp12_svf_lp;
      
      // -- mod="clp" dstVar=out
      if(out > 0.999f) out = 0.999f;
      else if(out < -0.999f) out = -0.999f;
      
      // -- mod="fma" dstVar=out
      out = (out * 0.49f) + 0.5f;
      
      // -- mod="lut" dstVar=out
      out = voice->lut_ws_inv[((unsigned int)(out * 4095)) & 4095];
      
      // -- mod="svf" dstVar=out
      
      // ---- mod="svf" input "res" seq 1/1
      
      // -- mod="$m_res" dstVar=voice->tmp20_res
      voice->tmp20_res = voice->mod_res_cur;
      
      // ---- mod="svf" input "freq" seq 1/1
      
      // -- mod="$v_cutoff" dstVar=voice->tmp21_freq
      voice->tmp21_freq = voice->var_v_cutoff;
      voice->tmp17_svf_lp = voice->tmp17_svf_lp + (voice->tmp19_svf_bp * voice->tmp21_freq);
      voice->tmp18_svf_hp = out - voice->tmp17_svf_lp - (voice->tmp19_svf_bp * voice->tmp20_res);
      voice->tmp19_svf_bp = voice->tmp19_svf_bp + (voice->tmp18_svf_hp * voice->tmp21_freq);
      out = voice->tmp17_svf_lp;
      
      // -- mod="clp" dstVar=out
      if(out > 0.999f) out = 0.999f;
      else if(out < -0.999f) out = -0.999f;

      /* end calc */

#ifdef OVERSAMPLE_FACTOR
         outOS += out;
#endif // OVERSAMPLE_FACTOR
      }
#ifdef OVERSAMPLE_FACTOR
      // Apply lowpass filter before downsampling
      //   (note) normalized Fc = F/Fs = 0.442947 / sqrt(oversample_factor - 1)
      out = outOS * (1.0f / OVERSAMPLE_FACTOR);
#endif // OVERSAMPLE_FACTOR
      _samplesOut[k]      = out;
      _samplesOut[k + 1u] = out;

      // Next frame
      k += 2u;
      voice->note_speed_cur += voice->note_speed_inc;
      voice->mod_cutoff_cur        += voice->mod_cutoff_inc;
      voice->mod_res_cur           += voice->mod_res_inc;
      voice->mod_exp_cur           += voice->mod_exp_inc;
   } /* loop numFrames */
}

static st_plugin_shared_t *ST_PLUGIN_API loc_shared_new(st_plugin_info_t *_info) {
   inv_lut_osc_1_shared_t *ret = (inv_lut_osc_1_shared_t *)malloc(sizeof(inv_lut_osc_1_shared_t));
   if(NULL != ret)
   {
      memset((void*)ret, 0, sizeof(*ret));
      ret->base.info  = _info;
      memcpy((void*)ret->params, (void*)loc_param_resets, NUM_PARAMS * sizeof(float));
   }
   return &ret->base;
}

static void ST_PLUGIN_API loc_shared_delete(st_plugin_shared_t *_shared) {
   free((void*)_shared);
}

static st_plugin_voice_t *ST_PLUGIN_API loc_voice_new(st_plugin_info_t *_info) {
   inv_lut_osc_1_voice_t *voice = (inv_lut_osc_1_voice_t *)malloc(sizeof(inv_lut_osc_1_voice_t));
   if(NULL != voice)
   {
      memset((void*)voice, 0, sizeof(*voice));
      voice->base.info = _info;
   }
   return &voice->base;
}

static void ST_PLUGIN_API loc_voice_delete(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(inv_lut_osc_1_voice_t);

   free((void*)_voice);
}

static void ST_PLUGIN_API loc_plugin_exit(st_plugin_info_t *_info) {
   free((void*)_info);
}

#ifdef USE_CYCLE_SINE_TBL
static void loc_calc_sine_tbl(void) {
#define QCOS_BITS 16
#define QCOS_ONE  (1 << QCOS_BITS)
#define QCOS_MASK (QCOS_ONE - 1)
   // (note) same as in TSR "C" implementation
   float *qcos = cycle_sine_tbl_f + 4096; // quarter cos tbl

   // calc quarter cos tbl
   int k = 0;
   for(int a = 0; a < (QCOS_ONE/4); a += (QCOS_ONE/16384)/*4*/)  // 4096 elements
   {
      int x = a - ((int)(QCOS_ONE * 0.25 + 0.5)) + ((a + ((int)(QCOS_ONE * 0.25 + 0.5)))&~QCOS_MASK);
      x = ((x * ((x<0?-x:x) - ((int)(QCOS_ONE * 0.5 + 0.5)))) >> QCOS_BITS) << 4;
      x += (((((int)(QCOS_ONE * 0.225 + 0.5)) * x) >> QCOS_BITS) * ((x<0?-x:x) - QCOS_ONE)) >> QCOS_BITS;
      qcos[k++] = x / float(QCOS_ONE);
   }

   // 0..90 (rev qtbl)
   int j = 4096;
   k = 0;
   loop(4096)
      cycle_sine_tbl_f[k++] = qcos[--j];

   // 90..180 = cos tbl
   k += 4096;

   // 180..360 (y-flip first half of tbl)
   j = 0;
   loop(8192)
      cycle_sine_tbl_f[k++] = -cycle_sine_tbl_f[j++];

#ifdef USE_CYCLE_SINE_TBL_I
   loop(16384)
      cycle_sine_tbl_i[i] = (short)(cycle_sine_tbl_f[i] * 2048.0f/*FX_ONE*/);
#endif // USE_CYCLE_SINE_TBL_I
}
#endif // USE_CYCLE_SINE_TBL

extern "C" {
st_plugin_info_t *inv_lut_osc_1_init(void) {
   inv_lut_osc_1_info_t *ret = (inv_lut_osc_1_info_t *)malloc(sizeof(inv_lut_osc_1_info_t));

   if(NULL != ret)
   {
      memset(ret, 0, sizeof(*ret));

      ret->base.api_version = ST_PLUGIN_API_VERSION;
      ret->base.id          = "inv_lut_osc_1";  // unique id. don't change this in future builds.
      ret->base.author      = "bsp";
      ret->base.name        = "inv lut osc 1";
      ret->base.short_name  = "inv lut osc 1";
      ret->base.flags       = ST_PLUGIN_FLAG_OSC;
      ret->base.category    = ST_PLUGIN_CAT_UNKNOWN;
      ret->base.num_params  = NUM_PARAMS;
      ret->base.num_mods    = NUM_MODS;

      ret->base.shared_new       = &loc_shared_new;
      ret->base.shared_delete    = &loc_shared_delete;
      ret->base.voice_new        = &loc_voice_new;
      ret->base.voice_delete     = &loc_voice_delete;
      ret->base.get_param_name   = &loc_get_param_name;
      ret->base.get_param_reset  = &loc_get_param_reset;
      ret->base.get_param_value  = &loc_get_param_value;
      ret->base.set_param_value  = &loc_set_param_value;
      ret->base.get_mod_name     = &loc_get_mod_name;
      ret->base.set_sample_rate  = &loc_set_sample_rate;
      ret->base.note_on          = &loc_note_on;
      ret->base.set_mod_value    = &loc_set_mod_value;
      ret->base.prepare_block    = &loc_prepare_block;
      ret->base.process_replace  = &loc_process_replace;
      ret->base.plugin_exit      = &loc_plugin_exit;

#ifdef USE_CYCLE_SINE_TBL
      loc_calc_sine_tbl();
#endif // USE_CYCLE_SINE_TBL
   }

   return &ret->base;
}

#ifndef STFX_SKIP_MAIN_INIT
ST_PLUGIN_APICALL st_plugin_info_t *ST_PLUGIN_API st_plugin_init(unsigned int _pluginIdx) {
   switch(_pluginIdx)
   {
      case 0u:
         return inv_lut_osc_1_init();
   }
   return NULL;
}
#endif // STFX_SKIP_MAIN_INIT

} // extern "C"
